#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class dmath {
        
        public static dvec2 Dot(dmat2 t0, dvec2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec2 Dot(ref dmat2 t0, ref dvec2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2 Dot(dmat2 t0, dmat2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2 Dot(ref dmat2 t0, ref dmat2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2x3 Dot(dmat2 t0, dmat2x3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2x3 Dot(ref dmat2 t0, ref dmat2x3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2x4 Dot(dmat2 t0, dmat2x4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2x4 Dot(ref dmat2 t0, ref dmat2x4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec2 Dot(dmat2x3 t0, dvec3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec2 Dot(ref dmat2x3 t0, ref dvec3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2 Dot(dmat2x3 t0, dmat3x2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2 Dot(ref dmat2x3 t0, ref dmat3x2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2x3 Dot(dmat2x3 t0, dmat3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2x3 Dot(ref dmat2x3 t0, ref dmat3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2x4 Dot(dmat2x3 t0, dmat3x4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2x4 Dot(ref dmat2x3 t0, ref dmat3x4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec2 Dot(dmat2x4 t0, dvec4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec2 Dot(ref dmat2x4 t0, ref dvec4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2 Dot(dmat2x4 t0, dmat4x2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2 Dot(ref dmat2x4 t0, ref dmat4x2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2x3 Dot(dmat2x4 t0, dmat4x3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2x3 Dot(ref dmat2x4 t0, ref dmat4x3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2x4 Dot(dmat2x4 t0, dmat4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat2x4 Dot(ref dmat2x4 t0, ref dmat4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec3 Dot(dmat3x2 t0, dvec2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec3 Dot(ref dmat3x2 t0, ref dvec2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3x2 Dot(dmat3x2 t0, dmat2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3x2 Dot(ref dmat3x2 t0, ref dmat2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3 Dot(dmat3x2 t0, dmat2x3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3 Dot(ref dmat3x2 t0, ref dmat2x3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3x4 Dot(dmat3x2 t0, dmat2x4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3x4 Dot(ref dmat3x2 t0, ref dmat2x4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec3 Dot(dmat3 t0, dvec3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec3 Dot(ref dmat3 t0, ref dvec3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3x2 Dot(dmat3 t0, dmat3x2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3x2 Dot(ref dmat3 t0, ref dmat3x2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3 Dot(dmat3 t0, dmat3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3 Dot(ref dmat3 t0, ref dmat3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3x4 Dot(dmat3 t0, dmat3x4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3x4 Dot(ref dmat3 t0, ref dmat3x4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec3 Dot(dmat3x4 t0, dvec4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec3 Dot(ref dmat3x4 t0, ref dvec4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3x2 Dot(dmat3x4 t0, dmat4x2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3x2 Dot(ref dmat3x4 t0, ref dmat4x2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3 Dot(dmat3x4 t0, dmat4x3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3 Dot(ref dmat3x4 t0, ref dmat4x3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3x4 Dot(dmat3x4 t0, dmat4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat3x4 Dot(ref dmat3x4 t0, ref dmat4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec4 Dot(dmat4x2 t0, dvec2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec4 Dot(ref dmat4x2 t0, ref dvec2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4x2 Dot(dmat4x2 t0, dmat2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4x2 Dot(ref dmat4x2 t0, ref dmat2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4x3 Dot(dmat4x2 t0, dmat2x3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4x3 Dot(ref dmat4x2 t0, ref dmat2x3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4 Dot(dmat4x2 t0, dmat2x4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4 Dot(ref dmat4x2 t0, ref dmat2x4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec4 Dot(dmat4x3 t0, dvec3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec4 Dot(ref dmat4x3 t0, ref dvec3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4x2 Dot(dmat4x3 t0, dmat3x2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4x2 Dot(ref dmat4x3 t0, ref dmat3x2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4x3 Dot(dmat4x3 t0, dmat3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4x3 Dot(ref dmat4x3 t0, ref dmat3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4 Dot(dmat4x3 t0, dmat3x4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4 Dot(ref dmat4x3 t0, ref dmat3x4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec4 Dot(dmat4 t0, dvec4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dvec4 Dot(ref dmat4 t0, ref dvec4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4x2 Dot(dmat4 t0, dmat4x2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4x2 Dot(ref dmat4 t0, ref dmat4x2 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4x3 Dot(dmat4 t0, dmat4x3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4x3 Dot(ref dmat4 t0, ref dmat4x3 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4 Dot(dmat4 t0, dmat4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
        
        public static dmat4 Dot(ref dmat4 t0, ref dmat4 t1) {
            return dmath.InnerProduct1(ref t0, ref t1);
        }
    }
}
