#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class math {
        
        public static vec2 Dot(mat2 t0, vec2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec2 Dot(ref mat2 t0, ref vec2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2 Dot(mat2 t0, mat2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2 Dot(ref mat2 t0, ref mat2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2x3 Dot(mat2 t0, mat2x3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2x3 Dot(ref mat2 t0, ref mat2x3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2x4 Dot(mat2 t0, mat2x4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2x4 Dot(ref mat2 t0, ref mat2x4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec2 Dot(mat2x3 t0, vec3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec2 Dot(ref mat2x3 t0, ref vec3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2 Dot(mat2x3 t0, mat3x2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2 Dot(ref mat2x3 t0, ref mat3x2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2x3 Dot(mat2x3 t0, mat3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2x3 Dot(ref mat2x3 t0, ref mat3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2x4 Dot(mat2x3 t0, mat3x4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2x4 Dot(ref mat2x3 t0, ref mat3x4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec2 Dot(mat2x4 t0, vec4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec2 Dot(ref mat2x4 t0, ref vec4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2 Dot(mat2x4 t0, mat4x2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2 Dot(ref mat2x4 t0, ref mat4x2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2x3 Dot(mat2x4 t0, mat4x3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2x3 Dot(ref mat2x4 t0, ref mat4x3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2x4 Dot(mat2x4 t0, mat4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat2x4 Dot(ref mat2x4 t0, ref mat4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec3 Dot(mat3x2 t0, vec2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec3 Dot(ref mat3x2 t0, ref vec2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3x2 Dot(mat3x2 t0, mat2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3x2 Dot(ref mat3x2 t0, ref mat2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3 Dot(mat3x2 t0, mat2x3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3 Dot(ref mat3x2 t0, ref mat2x3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3x4 Dot(mat3x2 t0, mat2x4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3x4 Dot(ref mat3x2 t0, ref mat2x4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec3 Dot(mat3 t0, vec3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec3 Dot(ref mat3 t0, ref vec3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3x2 Dot(mat3 t0, mat3x2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3x2 Dot(ref mat3 t0, ref mat3x2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3 Dot(mat3 t0, mat3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3 Dot(ref mat3 t0, ref mat3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3x4 Dot(mat3 t0, mat3x4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3x4 Dot(ref mat3 t0, ref mat3x4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec3 Dot(mat3x4 t0, vec4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec3 Dot(ref mat3x4 t0, ref vec4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3x2 Dot(mat3x4 t0, mat4x2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3x2 Dot(ref mat3x4 t0, ref mat4x2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3 Dot(mat3x4 t0, mat4x3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3 Dot(ref mat3x4 t0, ref mat4x3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3x4 Dot(mat3x4 t0, mat4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat3x4 Dot(ref mat3x4 t0, ref mat4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec4 Dot(mat4x2 t0, vec2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec4 Dot(ref mat4x2 t0, ref vec2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4x2 Dot(mat4x2 t0, mat2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4x2 Dot(ref mat4x2 t0, ref mat2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4x3 Dot(mat4x2 t0, mat2x3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4x3 Dot(ref mat4x2 t0, ref mat2x3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4 Dot(mat4x2 t0, mat2x4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4 Dot(ref mat4x2 t0, ref mat2x4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec4 Dot(mat4x3 t0, vec3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec4 Dot(ref mat4x3 t0, ref vec3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4x2 Dot(mat4x3 t0, mat3x2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4x2 Dot(ref mat4x3 t0, ref mat3x2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4x3 Dot(mat4x3 t0, mat3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4x3 Dot(ref mat4x3 t0, ref mat3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4 Dot(mat4x3 t0, mat3x4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4 Dot(ref mat4x3 t0, ref mat3x4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec4 Dot(mat4 t0, vec4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static vec4 Dot(ref mat4 t0, ref vec4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4x2 Dot(mat4 t0, mat4x2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4x2 Dot(ref mat4 t0, ref mat4x2 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4x3 Dot(mat4 t0, mat4x3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4x3 Dot(ref mat4 t0, ref mat4x3 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4 Dot(mat4 t0, mat4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
        
        public static mat4 Dot(ref mat4 t0, ref mat4 t1) {
            return math.InnerProduct1(ref t0, ref t1);
        }
    }
}
