#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class umath {
        
        public static uvec2 Dot(umat2 t0, uvec2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec2 Dot(ref umat2 t0, ref uvec2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2 Dot(umat2 t0, umat2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2 Dot(ref umat2 t0, ref umat2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2x3 Dot(umat2 t0, umat2x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2x3 Dot(ref umat2 t0, ref umat2x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2x4 Dot(umat2 t0, umat2x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2x4 Dot(ref umat2 t0, ref umat2x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec2 Dot(umat2x3 t0, uvec3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec2 Dot(ref umat2x3 t0, ref uvec3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2 Dot(umat2x3 t0, umat3x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2 Dot(ref umat2x3 t0, ref umat3x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2x3 Dot(umat2x3 t0, umat3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2x3 Dot(ref umat2x3 t0, ref umat3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2x4 Dot(umat2x3 t0, umat3x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2x4 Dot(ref umat2x3 t0, ref umat3x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec2 Dot(umat2x4 t0, uvec4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec2 Dot(ref umat2x4 t0, ref uvec4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2 Dot(umat2x4 t0, umat4x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2 Dot(ref umat2x4 t0, ref umat4x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2x3 Dot(umat2x4 t0, umat4x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2x3 Dot(ref umat2x4 t0, ref umat4x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2x4 Dot(umat2x4 t0, umat4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat2x4 Dot(ref umat2x4 t0, ref umat4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec3 Dot(umat3x2 t0, uvec2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec3 Dot(ref umat3x2 t0, ref uvec2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3x2 Dot(umat3x2 t0, umat2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3x2 Dot(ref umat3x2 t0, ref umat2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3 Dot(umat3x2 t0, umat2x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3 Dot(ref umat3x2 t0, ref umat2x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3x4 Dot(umat3x2 t0, umat2x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3x4 Dot(ref umat3x2 t0, ref umat2x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec3 Dot(umat3 t0, uvec3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec3 Dot(ref umat3 t0, ref uvec3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3x2 Dot(umat3 t0, umat3x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3x2 Dot(ref umat3 t0, ref umat3x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3 Dot(umat3 t0, umat3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3 Dot(ref umat3 t0, ref umat3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3x4 Dot(umat3 t0, umat3x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3x4 Dot(ref umat3 t0, ref umat3x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec3 Dot(umat3x4 t0, uvec4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec3 Dot(ref umat3x4 t0, ref uvec4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3x2 Dot(umat3x4 t0, umat4x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3x2 Dot(ref umat3x4 t0, ref umat4x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3 Dot(umat3x4 t0, umat4x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3 Dot(ref umat3x4 t0, ref umat4x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3x4 Dot(umat3x4 t0, umat4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat3x4 Dot(ref umat3x4 t0, ref umat4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec4 Dot(umat4x2 t0, uvec2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec4 Dot(ref umat4x2 t0, ref uvec2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4x2 Dot(umat4x2 t0, umat2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4x2 Dot(ref umat4x2 t0, ref umat2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4x3 Dot(umat4x2 t0, umat2x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4x3 Dot(ref umat4x2 t0, ref umat2x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4 Dot(umat4x2 t0, umat2x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4 Dot(ref umat4x2 t0, ref umat2x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec4 Dot(umat4x3 t0, uvec3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec4 Dot(ref umat4x3 t0, ref uvec3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4x2 Dot(umat4x3 t0, umat3x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4x2 Dot(ref umat4x3 t0, ref umat3x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4x3 Dot(umat4x3 t0, umat3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4x3 Dot(ref umat4x3 t0, ref umat3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4 Dot(umat4x3 t0, umat3x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4 Dot(ref umat4x3 t0, ref umat3x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec4 Dot(umat4 t0, uvec4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec4 Dot(ref umat4 t0, ref uvec4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4x2 Dot(umat4 t0, umat4x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4x2 Dot(ref umat4 t0, ref umat4x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4x3 Dot(umat4 t0, umat4x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4x3 Dot(ref umat4 t0, ref umat4x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4 Dot(umat4 t0, umat4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static umat4 Dot(ref umat4 t0, ref umat4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
    }
}
